#include <iostream>
#include <string>
#include <stdexcept>

#include "wrapper.hpp"

using namespace std;
using namespace A;

struct sprod_s 
{
	string left;
	string right;

	sprod_s() { }
	sprod_s(const string& l, const string& r) : left(l), right(r) { }
};

typedef wrapper<sprod_s>  sprod;

inline sprod make_sprod(const string& l, const string& r)
{
	return sprod(sprod_s(l, r));
}

int main(int argc, char** argv)
{
	sprod a = make_sprod("ab", "cd");
	sprod_s x = a.get_obj();
	cout << "<" << x.left << "|" << x.right << ">" << endl;
	cout << "Object info: " <<  a.get_info() << endl;

	return 0;
}


