#include <string>

namespace A {

extern std::string next_info;

template<class T> class wrapper;

template<class T> class wrapper
{
	private:
		static std::string info;
	
	public:
		static std::string get_info() { return info; }
		T& get_obj() { return obj; }
		const T get_obj() const {return obj; }

		wrapper() { }
		wrapper(const T& t) : obj(t) { }

	private:
		T obj;
};

template<class T> std::string wrapper<T>::info = next_info;

}


